Index: res/res_pjsip_pubsub.c
===================================================================
--- res/res_pjsip_pubsub.c	(revision 424090)
+++ res/res_pjsip_pubsub.c	(revision 424092)
@@ -1142,6 +1142,10 @@
 {
 	int i;
 
+	if (!sub) {
+		return;
+	}
+
 	if (AST_VECTOR_SIZE(&sub->children) > 0) {
 		for (i = 0; i < AST_VECTOR_SIZE(&sub->children); ++i) {
 			shutdown_subscriptions(AST_VECTOR_GET(&sub->children, i));
@@ -1357,6 +1361,11 @@
 		ast_sip_pubsub_has_eventlist_support(&rdata));
 	if (PJSIP_IS_STATUS_IN_CLASS(resp, 200)) {
 		sub_tree = create_subscription_tree(handler, endpoint, &rdata, resource, generator, &tree);
+		if (!sub_tree) {
+			ast_sorcery_delete(ast_sip_get_sorcery(), persistence);
+			ast_log(LOG_ERROR, "FAILED to re-create subscription\n");
+			return 0;
+		}
 		sub_tree->persistence = ao2_bump(persistence);
 		subscription_persistence_update(sub_tree, &rdata);
 	} else {
